;Cube Conquest (Working Title)
;------------------------------------------------------
;$Id: cubeconq.s,v 1.1.2.6 2002/08/18 01:46:07 Billy Exp $
;------------------------------------------------------
	processor 6502
    include "vcs.h"
;color defines
GRAY		=	$00
GOLD		=	$10
ORANGE		=	$20
BRT_ORANGE	=	$30
PINK		=	$40
PURPLE		=	$50
PURPLE_BLUE	=	$70
BLUE		=	$80
GREEN		=	$C0
LT_ORANGE	=	$F0

LUM1		= 	$00	
LUM2		=	$02
LUM3		= 	$04	
LUM4		= 	$06	
LUM5		= 	$08	
LUM6		= 	$0a	
LUM7		= 	$0c	
LUM8		=	$0e

LIGHTBLUE	=	BLUE | LUM1
LIGHTPINK	= 	PINK | LUM1

LIGHTGRAY	=	GRAY | LUM3
BLACK		= 	GRAY | LUM1
WHITE		=	$FF

MEDIUMRED	=	BRT_ORANGE | LUM3
MEDIUMGREEN	=	GREEN | LUM4

P0COLOR		=	MEDIUMRED
P1COLOR		=	MEDIUMGREEN



;Ram variables
	        SEG.U   variables
	       	org $80
	        
interlaced	ds	1
	        
framenum	ds	1
evenframe	ds	1

xpos0		ds	1
ypos0		ds	1

xmove0		ds	1
ymove0		ds	1

xpos1		ds	1
ypos1		ds	1

curry		ds	1

rand0		ds	1			;16 bit random number (random routines in common.s)
rand1		ds	1
moving		ds	1
delay_switch	ds	1		;used to delay switch checking
TEMP
temp0		ds	1
temp1		ds	1
temp2		ds	1
temp3		ds	1

	SEG code

	org	$f000
	include "common.s"				;common subs
	include	"FC_position.s"
	include "position_players.s"
;Setup stuff
start
	sei             ;clear interupts
	cld             ;set to non-BCD mode
    
;Clear all memory except $ff/$1ff - Stack end
	lda #0
clear
	sta $ff,x		;x still has $ff in it
	dex
	bne clear		;x comes out with 0

main_game

normal_repeat				;repeat point
	
;set player numbers to triple
	lda	#$00
	sta	NUSIZ0
	sta	NUSIZ1

;setup the missiles
	lda	#$02
	sta	RESMP0		;lock the missiles to the players (and disable)
	sta	RESMP1

;set background
	lda #BLACK
	sta COLUBK

;starting x of sprites
	lda	#50		
	sta	xpos0
	lda	#38
	sta xpos1
	
	lda	#254
	sta ypos0

;set framenum	
	lda	#4
	sta	framenum

frame
;Vertical sync
	dec	framenum
	lda #$01
	and framenum
	sta	evenframe
	
	lda evenframe
	jsr vertical_sync_interlaced

;this contains the positioning routine, 4 scan lines 
	jsr position_player0
	jsr position_player1	
;wait for the vertical blank to end

	jsr wait_timer
	sta	WSYNC	;37th line of VBLANK

	sta	VBLANK   ;A comes back as zero, end vblank
	sta WSYNC
	sta WSYNC

;start visible area
;first draw some diagonal lines
	lda evenframe 	;see which frame I'm on
	beq diags_even

diags_odd
	lda	#$40
	ldy	#4			
diags_inner_odd
	sta WSYNC		
	sta	GRP0		
	sta GRP1
	lsr				;shift bit over twice
	lsr
	dey
	bne diags_inner_odd
	jmp done_diags	

diags_even	
	lda	#$80
	ldy	#4			
diags_inner_even
	sta WSYNC
	sta	GRP0
	sta GRP1
	lsr				;shift bit over twice
	lsr
	dey
	bne diags_inner_even
done_diags
	
	sta WSYNC 		;end of 26th/beginning of 27th line
	lda	#0
	sta GRP0		;kill the graphics
	sta GRP1	
	
	ldy	#5			;place holder for the score
	jsr wait_lines
	lda	#LIGHTGRAY
	sta COLUBK
	lda	#BLACK
	sta WSYNC	;end of 11th line
	sta COLUBK
	
	
	lda	#P0COLOR	;set up my player colors
	sta	COLUP0
	lda	#P1COLOR
	sta	COLUP1
	
;first 100 lines will never have players on them
	lda	#100
	sta	curry
	
	
;	lda framenum	
;	beq first_100_even
;	dec curry
	
	ldy	#50
	jsr wait_lines

;first_100_odd
;	sta WSYNC
;	dec curry
;	dec curry
;	bpl first_100_odd
;	bmi done_first_100
	
;first_100_even	
;	sta WSYNC
;	dec curry
;	dec curry
;	beq	first_100_even
;done_first_100

	lda	#0
	sta curry
	
;line 61

	lda	#P0COLOR
	sta COLUP0
	
;	lda moving
;	beq	not_moving
;	lda #BLACK
;	sta COLUP0
not_moving

	lda	evenframe
	beq	main_field_even
	inc curry
main_field_odd
	sta WSYNC
;	lda moving
;	bne	no_ship_odd
	sec
	lda	ypos0
	sbc curry
	cmp	#15
	bcs no_ship_odd
	tax
	lda	spaceship,x
	sta GRP0	
	bne dec_curry_odd
no_ship_odd
	lda	#0
	sta GRP0
dec_curry_odd
	inc curry
	beq done_main_field
	inc curry
	bne main_field_odd
	
main_field_even	
	sta WSYNC
;	jmp no_ship_even
	lda moving
	bne	no_ship_even
	sec
	lda	ypos0
	sbc curry
	cmp	#15
	bcs no_ship_even
	tax
	lda	spaceship,x
	sta GRP0	
	bne dec_curry_even
no_ship_even
	lda	#0
	sta GRP0
dec_curry_even
	inc curry
	inc curry
	bne main_field_even

done_main_field
;line 188
	

;	lda framenum	
;	beq ships_even
;	
;ships_odd	
;	ldx #14			;x is an index into the graphic
;ships_odd_loop
;	lda	spaceship,x
;	sta WSYNC
;	sta GRP0
;	sta GRP1
;	dex				;need every other line
;	dex
;	bpl ships_odd_loop	

;	jmp done_ships

;ships_even
;	ldx #15	
;ships_even_loop
;	lda	spaceship,x
;	sta WSYNC
;	sta GRP0
;	sta GRP1
;	dex
;	dex
;	bpl ships_even_loop	
	
;done_ships
		
	sta WSYNC	;end of 45th/beginning of 46th
	lda #0		;kill the graphics
	sta GRP0
	sta GRP1

;line 69

	ldy #3
	jsr wait_lines



;Overscan
	jsr start_Overscan	

	lda delay_switch
	bne	skip_switch_check
;check for reset
	lda SWCHB
	and	#1
	bne	no_reset
reset
	lda	#15				;insert a delay
	sta delay_switch
	
	jmp	main_game
no_reset

;check for select
	lda SWCHB
	and #$02
	bne no_select

	lda #$FF
	eor	interlaced
	sta interlaced
	
	lda	#15				;insert a delay
	sta delay_switch	
	
no_select
skip_switch_check

;decrement delay_switch
	lda	delay_switch
	beq	no_dec_delay_switch
	dec delay_switch
no_dec_delay_switch

	lda	#0
	sta moving
	sta xmove0
	sta ymove0

;	lda evenframe
;	bne skip_joystick
	lda	framenum
;	beq check_joystick
;	cmp	#3	
	bne skip_joystick
check_joystick
	lda	SWCHA	
	asl
	bcs not_right
	inc xmove0
not_right
	asl
	bcs	not_left
	dec xmove0
not_left
	asl
	bcs	not_down
	inc ymove0
not_down
	asl
	bcs not_up
	dec ymove0
not_up
	
	lda	xmove0
	asl
	beq do_ymove0
	clc
	adc xpos0
	sta xpos0
	inc moving
do_ymove0
	lda ymove0
	asl
	asl
	beq done_move0
	clc
	adc ypos0
	sta ypos0
	inc moving
done_move0
	
	
skip_joystick
	
;wait for overscan to end
	jsr wait_timer
;wait_FF
;	lda INTIM		;timer ended?
;	bne	wait_FF

frame_done
;update framenum
	lda framenum
	bne no_update_framenum
	lda	#4
	sta framenum
no_update_framenum

	jmp frame

;this packs graphics.c and drawit.s all the way down to the bottom, where all should work	
	org	$fcf1		
	include "graphics.s"

;make sure nothing gets put here so unmodified superchargers 
;can play the game
	org	$fff8
	ds	4
;Boot up points....

	org	$fffc
	dc.w	start                    ; Reset vector
    dc.w	start                    ; IRQ vector

;------------------------------------------------------
;$Log: cubeconq.s,v $
;Revision 1.1.2.6  2002/08/18 01:46:07  Billy
;not much...
;
;Revision 1.1.2.5  2002/08/17 04:58:44  Billy
;interleaving improved
;
;Revision 1.1.2.4  2002/08/16 04:14:11  Billy
;maybe interlacing works.
;
;Revision 1.1.2.3  2002/08/16 02:38:45  Billy
;submitted to stella list, ugly
;
;Revision 1.1.2.2  2002/08/14 02:25:56  Billy
;experiment with changing background color
;
;Revision 1.1.2.1  2002/08/14 01:11:49  Billy
;Playfield experiments
;
;------------------------------------------------------
